	LIST		P=PIC18F2550
	#include	<P18f2550.INC>
;	__CONFIG	

loops		Equ	0x22		; Zhler fr Warteschleife 
loops2		Equ	0x23		; Zhler fr Warteschleife
count		equ	0x24		; universal counter
OSD_L		equ	0x25
OSD_H		equ	0x26
count2		equ	0x27
count3		equ	0x28

OSD_CSN		equ	0x00		; STV5730A ChipSelect Out
OSD_CLK		equ 0x01		; STV5730A Data Clock Out
OSD_DATA	equ	0x02		; STV5730A Data Out
OSD_SYNC	equ	0x03		; STV5730A Sync Detected In

; OSD_Text	db	0x10, 0x3d, 0x31, 0x2a, 0x37, 0x00

Init
		movlw	B'11111000'		; PortB 0-2 output
		movwf	TRISB
		bcf		INTCON2,RBPU	; enable internal pull-up resistors (check this!)
		call	Wait

rst_osd
		clrf	OSD_L
		movlw	0x30
		movwf	OSD_H
		call	tx_osd_16			; send 0x3000
		clrf	OSD_L
		movlw	0x30
		movwf	OSD_H
		call	tx_osd_16			; send 0x3000
		movlw	0xDB
		movwf	OSD_L
		clrf	OSD_H
		call	tx_osd_16			; send 0x00db
		clrf	OSD_L
		movlw	0x10
		movwf	OSD_H
		call	tx_osd_16			; send 0x1000
;		call	Wait
; init osd registers
		clrf	OSD_H
		movlw	B'11001100'			; Zoom Register (#12)
		movwf	OSD_L
		call	tx_osd_16			; send 0000000011001100 --> select zoom reg (12)
		movlw	B'00010000'
		movwf	OSD_H
		clrf	OSD_L
		call	tx_osd_16			; send 0001000000000000 --> write zoom reg (12)
		movlw	B'00010000'
		movwf	OSD_H
		clrf	OSD_L
		call	tx_osd_16			; send 0001000000000000 --> write color reg (13)
		movlw	B'00011011'			; 00011011 works
		movwf	OSD_H
		movlw	B'11010100'			; 11010100 works
		movwf	OSD_L
		call	tx_osd_16			; send 0001001111010100 --> write control reg (14)
		movlw	B'00010000'
		movwf	OSD_H
		movlw	B'00000000'
		movwf	OSD_L
		call	tx_osd_16			; send 0001100000100000 --> write (32/32) to position register (15)
		movlw	B'00010001'
		movwf	OSD_H
		movlw	B'00000100'
		movwf	OSD_L
		call	tx_osd_16			; send 0001000100100100 --> mode register (16)

;		call	Wait

ClrScr
		clrf	OSD_L
		clrf	OSD_H
		call	tx_osd_16			; set cursor to 0,0

		movlw	0x02
		movwf	count3
		movlw	D'60'
		movwf	count2			; 16-bit counter to clear 308 characters

;		call	Wait

ClrLoop							; write 255 "a" into screen memory
		movlw	B'00010111'
		movwf	OSD_H
		movlw	0x64			; 0x0B = " "
		movwf	OSD_L
		call	tx_osd_16
		decfsz	count2
		bra		ClrLoop
		decfsz	count3
		bra		ClrLoop

;		call	Wait

ClrRows
		clrf	OSD_L
		clrf	OSD_H
		call	tx_osd_16			; set cursor to 0,0
		clrf	OSD_H
		movlw	B'11000000'
		movwf	OSD_L
		call	tx_osd_16			; set write pointer to row attribute #0

		movlw	D'12'
		movwf	count2
RowLoop
		movlw	B'00010000'
		movwf	OSD_H
		movlw	B'11000000'
		movwf	OSD_L
		call	tx_osd_16			; write '0001000011000000' to rows 0-11
		decfsz	count2
		bra		RowLoop

;		call	Wait

TestMsg
		clrf	OSD_L
		clrf	OSD_H
		call	tx_osd_16			; set cursor to 0,0
		movlw	B'00010111'
		movwf	OSD_H
		movlw	0x90
		movwf	OSD_L
		call	tx_osd_16			; write "E"
		call	Wait
		movlw	0x3d
		call	tx_osd_08			; write "t"
		call	Wait
		movlw	0x31
		call	tx_osd_08			; write "h"
		call	Wait
		movlw	0x2a
		call	tx_osd_08			; write "a"
		call	Wait
		movlw	0x37
		call	tx_osd_08			; write "n"

loop
;		btg		PORTB,OSD_DATA
;		call	Wait
;		btg		PORTB,OSD_DATA
;		call	Wait
;		goto	loop			; 

; REMEMBER!!! this will overwrite any other control reg changes made initially!!

		btfsc	PORTB,OSD_SYNC
		bra		nosync
								; set mixed screen mode
		clrf	OSD_H
		movlw	B'11001110'		; Control Register (#14)
		movwf	OSD_L
		call	tx_osd_16			; send 0000000011001110 --> select control reg
		movlw	B'00011011'
		movwf	OSD_H
		movlw	B'11010100'
		movwf	OSD_L
		call	tx_osd_16			; send 0001001111010100 --> write control reg
		goto	loop
nosync							; set full screen mode
		clrf	OSD_H
		movlw	B'11001111'		; Control Register (#14)
		movwf	OSD_L
		call	tx_osd_16			; send 0000000011001110 --> select control reg
		movlw	B'00011011'
		movwf	OSD_H
		movlw	B'11010100'
		movwf	OSD_L
		call	tx_osd_16			; send 0001001111010100 --> write control reg
		goto	loop

;**************************************************************
; sends 0, 8 or 16-bit word to OSD controller
; for 8-bit transaction, store data into W
; for 16-bit transfers, store H into OSD_H and L into W

tx_osd_00
		bsf     PORTB,OSD_CLK		; set clk high
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		bcf		PORTB,OSD_CSN		; set csn low (selected)
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		bsf		PORTB,OSD_CSN
		nop
		nop
		nop							; for safe timing
		nop							; for safe timing
		bcf		PORTB,OSD_CLK
		return
tx_osd_08
		movwf	OSD_H
		movlw	0x08
		movwf	count
		bra		osd_next
tx_osd_16
		movlw	0x10
		movwf	count
osd_next
		bsf     PORTB,OSD_CLK		; set clk high
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		bcf		PORTB,OSD_CSN		; set csn low (selected)
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		
loop1	bcf		PORTB,OSD_CLK		; clk output low
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		rlcf	OSD_L				; rotate low byte left into carry
		rlcf	OSD_H				; rotate high byte left into carry
		bc		hi					; branch if carry
		bcf		PORTB,OSD_DATA		; set OSD data out low
		bra		end1
hi		bsf		PORTB,OSD_DATA		; set OSD data out high
end1
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		bsf		PORTB,OSD_CLK		; CLK high --> data valid
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		decfsz	count				; skip next cmd if count is now zero
		bra		loop1				; process next bit
		
		bsf		PORTB,OSD_CSN		; csn high (deselected)
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		bcf		PORTB,OSD_CLK		; clk low - really necessary?
		call	wait125
		nop							; for safe timing
		nop							; for safe timing
		nop							; for safe timing
		return

;**********************************************************
; Warteschleife 500 ms

Wait
	movlw	D'200'		; 500 ms Pause
	movwf	loops	

Wai
	movlw   D'249'           ; Zeitkonstante fr 2.5ms
        movwf   loops2
Wai2    nop                    ; 83 cycles = 10s (assuming 12 MIPS)
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        decfsz  loops2, F      ; 1 ms vorbei?
        goto    Wai2           ; nein, noch nicht
                               ;
        decfsz  loops, F       ; 250 ms vorbei?
        goto    Wai            ; nein, noch nicht
        retlw   0              ; das Warten hat ein Ende


;******************
wait125	clrf	loops			; this loop takes about 125s
loop250	decfsz	loops			; 255 cycles
		bra		loop250
		return

		end
